Index: trunk/zoo-services/ogr/base-vect-ops/cgi-env/Boundary.zcfg
===================================================================
--- trunk/zoo-services/ogr/base-vect-ops/cgi-env/Boundary.zcfg	(revision 55)
+++ trunk/zoo-services/ogr/base-vect-ops/cgi-env/Boundary.zcfg	(revision 80)
@@ -16,5 +16,5 @@
    minOccurs = 1
    maxOccurs = 1
-   <MetaData lang="en">
+   <MetaData>
     title = Mon test  
    </MetaData>   
@@ -36,5 +36,5 @@
    Title = The geometry created
    Abstract = The geometry containing the boundary of the geometry on which the method is invoked.
-   <MetaData lang="en">
+   <MetaData>
     title = Mon test  
    </MetaData>   
Index: trunk/zoo-services/ogr/base-vect-ops/cgi-env/Buffer.zcfg
===================================================================
--- trunk/zoo-services/ogr/base-vect-ops/cgi-env/Buffer.zcfg	(revision 55)
+++ trunk/zoo-services/ogr/base-vect-ops/cgi-env/Buffer.zcfg	(revision 80)
@@ -8,5 +8,5 @@
  serviceProvider = ogr_service.zo
  serviceType = C
- <MetaData lang="en">
+ <MetaData>
    title = Demo
  </MetaData>
@@ -17,5 +17,5 @@
    minOccurs = 1
    maxOccurs = 1
-   <MetaData lang="en">
+   <MetaData>
     title = Mon test  
    </MetaData>   
@@ -52,5 +52,5 @@
    Title = Buffered Polygon
    Abstract = GML stream describing the buffered polygon feature.
-   <MetaData lang="en">
+   <MetaData>
     title = Mon test  
    </MetaData>   
Index: trunk/zoo-services/ogr/base-vect-ops/cgi-env/Centroid.zcfg
===================================================================
--- trunk/zoo-services/ogr/base-vect-ops/cgi-env/Centroid.zcfg	(revision 55)
+++ trunk/zoo-services/ogr/base-vect-ops/cgi-env/Centroid.zcfg	(revision 80)
@@ -8,5 +8,5 @@
  serviceProvider = ogr_service.zo
  serviceType = C
- <MetaData lang="en">
+ <MetaData>
    title = Demo
  </MetaData>
@@ -17,5 +17,5 @@
    minOccurs = 1
    maxOccurs = 1
-   <MetaData lang="en">
+   <MetaData>
     title = Mon test  
    </MetaData>   
@@ -37,5 +37,5 @@
    Title = The Centroid
    Abstract = JSON String / GML Entity of the centroid
-   <MetaData lang="en">
+   <MetaData>
     title = Mon test  
    </MetaData>   
Index: trunk/zoo-services/ogr/base-vect-ops/cgi-env/ConvexHull.zcfg
===================================================================
--- trunk/zoo-services/ogr/base-vect-ops/cgi-env/ConvexHull.zcfg	(revision 55)
+++ trunk/zoo-services/ogr/base-vect-ops/cgi-env/ConvexHull.zcfg	(revision 80)
@@ -7,5 +7,5 @@
  serviceProvider = ogr_service.zo
  serviceType = C
- <MetaData lang="en">
+ <MetaData>
    title = Demo
  </MetaData>
@@ -16,5 +16,5 @@
    minOccurs = 1
    maxOccurs = 1
-   <MetaData lang="en">
+   <MetaData>
    title = Mon test
    </MetaData>
@@ -36,5 +36,5 @@
    Title = The convex hull of the geometry
    Abstract = The convex hull of the geometry
-   <MetaData lang="en">
+   <MetaData>
     title = Mon test  
    </MetaData>   
Index: trunk/zoo-services/ogr/base-vect-ops/cgi-env/Difference.zcfg
===================================================================
--- trunk/zoo-services/ogr/base-vect-ops/cgi-env/Difference.zcfg	(revision 55)
+++ trunk/zoo-services/ogr/base-vect-ops/cgi-env/Difference.zcfg	(revision 80)
@@ -17,5 +17,5 @@
    minOccurs = 1
    maxOccurs = 1
-   <MetaData lang="en">
+   <MetaData>
     title = Mon test  
    </MetaData>   
@@ -37,5 +37,5 @@
    minOccurs = 1
    maxOccurs = 1
-   <MetaData lang="en">
+   <MetaData>
     title = Mon test  
    </MetaData>   
@@ -57,5 +57,5 @@
    Title = The difference between two geometries
    Abstract = The difference between the two geometries.
-   <MetaData lang="en">
+   <MetaData>
     title = Mon test  
    </MetaData>   
Index: trunk/zoo-services/ogr/base-vect-ops/cgi-env/Distance.zcfg
===================================================================
--- trunk/zoo-services/ogr/base-vect-ops/cgi-env/Distance.zcfg	(revision 55)
+++ trunk/zoo-services/ogr/base-vect-ops/cgi-env/Distance.zcfg	(revision 80)
@@ -17,5 +17,5 @@
    minOccurs = 1
    maxOccurs = 1
-   <MetaData lang="en">
+   <MetaData>
     title = Mon test  
    </MetaData>   
@@ -37,5 +37,5 @@
    minOccurs = 1
    maxOccurs = 1
-   <MetaData lang="en">
+   <MetaData>
     title = Mon test  
    </MetaData>   
@@ -57,5 +57,5 @@
    Title = The distance between two geometries
    Abstract = The shortest distance between the two geometries.
-   <MetaData lang="en">
+   <MetaData>
     title = Mon test  
    </MetaData>   
Index: trunk/zoo-services/ogr/base-vect-ops/cgi-env/GetArea.zcfg
===================================================================
--- trunk/zoo-services/ogr/base-vect-ops/cgi-env/GetArea.zcfg	(revision 55)
+++ trunk/zoo-services/ogr/base-vect-ops/cgi-env/GetArea.zcfg	(revision 80)
@@ -7,5 +7,5 @@
  serviceProvider = ogr_service.zo
  serviceType = C
- <MetaData lang="en">
+ <MetaData>
    title = Demo
  </MetaData>
@@ -16,5 +16,5 @@
    minOccurs = 1
    maxOccurs = 1
-   <MetaData lang="en">
+   <MetaData>
    title = Mon test
    </MetaData>
@@ -36,5 +36,5 @@
    Title = Computed Area
    Abstract = The Computed Area Value
-   <MetaData lang="en">
+   <MetaData>
     title = Mon test  
    </MetaData>   
Index: trunk/zoo-services/ogr/base-vect-ops/cgi-env/Intersection.zcfg
===================================================================
--- trunk/zoo-services/ogr/base-vect-ops/cgi-env/Intersection.zcfg	(revision 55)
+++ trunk/zoo-services/ogr/base-vect-ops/cgi-env/Intersection.zcfg	(revision 80)
@@ -17,5 +17,5 @@
    minOccurs = 1
    maxOccurs = 1
-   <MetaData lang="en">
+   <MetaData>
     title = Mon test  
    </MetaData>   
@@ -37,5 +37,5 @@
    minOccurs = 1
    maxOccurs = 1
-   <MetaData lang="en">
+   <MetaData>
     title = Mon test  
    </MetaData>   
@@ -57,5 +57,5 @@
    Title = Intersection of geometries
    Abstract = A new geometry representing the intersection or NULL if there is no intersection or an error occurs.
-   <MetaData lang="en">
+   <MetaData>
     title = Mon test  
    </MetaData>   
Index: trunk/zoo-services/ogr/base-vect-ops/cgi-env/SymDifference.zcfg
===================================================================
--- trunk/zoo-services/ogr/base-vect-ops/cgi-env/SymDifference.zcfg	(revision 55)
+++ trunk/zoo-services/ogr/base-vect-ops/cgi-env/SymDifference.zcfg	(revision 80)
@@ -17,5 +17,5 @@
    minOccurs = 1
    maxOccurs = 1
-   <MetaData lang="en">
+   <MetaData>
     title = Mon test  
    </MetaData>   
@@ -37,5 +37,5 @@
    minOccurs = 1
    maxOccurs = 1
-   <MetaData lang="en">
+   <MetaData>
     title = Mon test  
    </MetaData>   
@@ -57,5 +57,5 @@
    Title = The resulting geometry
    Abstract = The symmetric difference of two geometries
-   <MetaData lang="en">
+   <MetaData>
     title = Mon test  
    </MetaData>   
Index: trunk/zoo-services/ogr/base-vect-ops/cgi-env/Union.zcfg
===================================================================
--- trunk/zoo-services/ogr/base-vect-ops/cgi-env/Union.zcfg	(revision 55)
+++ trunk/zoo-services/ogr/base-vect-ops/cgi-env/Union.zcfg	(revision 80)
@@ -17,5 +17,5 @@
    minOccurs = 1
    maxOccurs = 1
-   <MetaData lang="en">
+   <MetaData>
     title = Mon test  
    </MetaData>   
@@ -37,5 +37,5 @@
    minOccurs = 1
    maxOccurs = 1
-   <MetaData lang="en">
+   <MetaData>
     title = Mon test  
    </MetaData>   
@@ -57,5 +57,5 @@
    Title = The union of two geometries
    Abstract = The geometry representing the union of the two geometries.
-   <MetaData lang="en">
+   <MetaData>
     title = Mon test  
    </MetaData>